
#ifndef __Mod_GScript_Compile__
#define __Mod_GScript_Compile__

//----	⏕W[
#module "ModGS_Compile_Sub"
	//	sR[hCRLFɓꂷiłstatɉsԂj
	#deffunc gs_compile_crlf var p_var, local cr, local lf
		cr = " " : poke cr,0,13		//	CR
		lf = " " : poke lf,0,10		//	LF
		strrep p_var, "\n", lf		//	CRLF -> LF
		strrep p_var, cr, lf		//	CR -> LF
		strrep p_var, lf, "\n"		//	LF -> CRLF	
		return

	//	̉s𐔂
	#defcfunc gs_compile_get_crlf_count str p_string, local _temp
		_temp = p_string
		strrep _temp, "\n", "\n"
		return stat

	//	pX`
	//	擪 \ ͎菜
	//	\\  /  \ ɒu
	//	ŏII hoge\piyo\test.txt ̂悤Ȍ`ɂ
	#defcfunc gs_compile_format_path str p_string, local _temp
		_temp = p_string
		strrep _temp, "/", "\\"
		repeat
			strrep _temp, "\\\\", "\\" : if stat == 0 : break
		loop
		if peek(_temp,0) == '\\' : return strmid(_temp,1,260)
		return _temp
	
	//	tpX
	#defcfunc gs_compile_get_fullpath str p_string, local _temp, local _list, local _num, local _ct
		_temp = p_string
		if peek(_temp,1) != ':' {
			if wpeek(_temp,0) != 23598 {	//	23598 = .\
				_temp = dir_cur + "\\" + p_string
			} else {
				_temp = dir_cur + strmid( _temp, 1, strlen(_temp)-1)
			}
		}
		sdim _list
		split _temp, "\\", _list
		_num = stat
		repeat _num
			if _list(cnt) == ".." {
				_ct = cnt
				repeat ,1
					if (_ct-cnt) >= 0 {
						if _list(_ct-cnt) != "" {
							_list(_ct-cnt) = ""
							_list(_ct) = ""
							break
						}
						continue
					}
					break
				loop
			}
		loop
		_temp = _list
		repeat _num-1, 1
			if _list(cnt) != "" {
				_temp += "\\"+_list(cnt)
			}
		loop
		return _temp

#global

//----	XNvg̉͂ƕϊ
#module "ModGS_Compile"

#include "module_gs_wordgroup.as"

//			TokenType
#define		TT_FUNCTION		1		//	
#define		TT_PARAM		2		//	߂̃p[^ubN
#define		TT_VARIABLE		3		//	ϐ쎮
#define		TT_LABEL		4		//	x

#define		TT_BRACES_B		200		//	{
#define		TT_BRACES_C		201		//	}

#define		TT_RETURN		251		//	s
#define		TT_COLON		252		//	RAȂ͂ǒ`Ă

#define		TT_EOF			255		//	I_

//			ParserCallDefine
#define		PCD_FUNC_INIT			1
#define		PCD_BLOCK_TYPE_LINE		2
#define		PCD_BLOCK_TYPE_BRACES	3
#define		PCD_BLOCK_TYPE_FUNC		4

#define		wordgroup			wgtable@ModGS_Temp

#define		INCLUDE_LEVEL_LIMIT		16

	#deffunc gs_compile_init

		gs_define_add_preprocess "#define", *PREPROCESS_DEFINE		//	l╶Ȃǂ̒`
		gs_define_add_preprocess "#undef", *PREPROCESS_UNDEF		//	`̍폜
		gs_define_add_preprocess "#deflev", *PREPROCESS_DEFLEV		//	`xݒ 0=temp, 1=user

		gs_define_add_preprocess "#name", *PREPROCESS_NAME			//	OԂݒ
		gs_define_add_preprocess "#endname", *PREPROCESS_ENDNAME	//	OԂ

		gs_define_add_preprocess "#include", *PREPROCESS_INCLUDE	//	Ot@C
/*
		gs_define_add_preprocess "#if", *PREPROCESS_DEFINE			//	X^bN+ubNK{A
		gs_define_add_preprocess "#ifdef", *PREPROCESS_DEFINE
		gs_define_add_preprocess "#ifndef", *PREPROCESS_DEFINE
		gs_define_add_preprocess "#else", *PREPROCESS_DEFINE
		gs_define_add_preprocess "#endif", *PREPROCESS_DEFINE
*/
		ns_count = 0


		s_error = 0
		s_error_info= ""
		dim line_name
		dim line_current
		line_index = 0
		dim p_stack_name
		dim p_stack_line
		p_stack_index = 0

		return

	#include "module_gs_compile_error.as"

;#define global gsc_loaderror	s_error_info@ModGS_Compile
;	#defcfunc gsc_loaderror
;		return s_error_info@ModGS_Compile


	#define global gsc_Compile(%1,%2)	gs_compile_output %1, 3, %2, -1
	#deffunc gs_compile_output str p0, int p1, var p2, int p_encode, local _index, local _size
		_index = _gs_compile_main( p0, (p1|2), p_encode) : if _index < 0 : return _index
		gs_code_output _index, p2 : _size = stat
		gs_code_del _index
		gs_code_ns_decrease
		return _size

	#define global ctype gsc_Load(%1)				_gs_compile_main(%1, 1, -1)
	#define global ctype gs_compile_main(%1,%2)		_gs_compile_main(%1,%2,-1)
	#defcfunc _gs_compile_main str p0, int p1, int p_encode
		if _gsc_error : return -1
		//	p0	code_string
		//	p1	option
		//		&1	W namespace g
		//		&2	RpCɕϐ/x̃}bsOsȂ
		//	p_encode	͂̕R[h

		if p_encode == -1 {
			c_encode = gs_strmod_GetSystemEncode()
		} else {
			c_encode = p_encode
		}

		//	\[XƍsǗ
		tempstr			= p0
		gs_compile_crlf tempstr	//	sR[h
		dim line_current, INCLUDE_LEVEL_LIMIT
		dim line_max, INCLUDE_LEVEL_LIMIT
		sdim line_name, 64, INCLUDE_LEVEL_LIMIT
		sdim line_path, 260, INCLUDE_LEVEL_LIMIT
		line_max		= stat+1
		line_current	= 1
		line_name		= "root"
		line_index		= 0

		//	R[hXgɒǉ邽߂̃CfbNX擾
		gs_code_add 
		code_index		= stat

		compile_mode	= 1;((p1&2)!=0)
		compile_mapping	= ((p1&2)!=2)
		gs_calculate_compile_mode compile_mode, code_index

		//	`x
		code_deflev		= 0

		//	O
		//	ns_flag	0	
		//			1	W`
		//			2	[U[`
		ns_index		= 0
		
		sdim ns_name, 64, 64
		if (p1 & 1) && (GSMD_SCRIPT_NAMESPACE_DEFAULT != "") {
			ns_flag		= 1
			ns_name(ns_index) = GSMD_SCRIPT_NAMESPACE_DEFAULT + gs_code_get_nsID(code_index)
		} else {
			ns_flag		= 0
		}

		gs_calculate_namespace_swap	//	swap
		gs_calculate_namespace ns_name(ns_index)

		//	G[p
		s_error			= 0
		s_error_info	= ""

		//	parser
		p_code			= 0
		p_param			= 0
		p_temp			= ""
		p_stack_max		= 8
		p_stack_index	= 0
		ldim p_label, 1
		dim p_stack_ns, p_stack_max
		sdim p_stack_param, 16, p_stack_max
		sdim p_stack_data, 16, p_stack_max
		dim  p_stack_type, p_stack_max
		dim  p_stack_line, p_stack_max
		sdim p_stack_name, 64, p_stack_max
		
		p_block			= 0
		dim	p_block_type, 64
		dim	p_block_param, 64
		dim	p_block_func, 64

		//	lexer
		c_size			= 0
		c_pos			= 0
		c_index			= 0
		c_max			= strlen(tempstr)
		c_mode			= -WG_SPACE
		c_type			= 0
		c_param			= 0
		c_temp			= ""
		c_keyword		= ""
		c_break			= 0
		c_block			= 0
		c_parser_stack	= 0
		c_crlf			= 2		//	s 2 ɐݒ肳1擾 1 AXy[X̏ꍇ͌ȂB s # m邽߂Ɏg
		dim	c_block_type, 64
		dim	c_block_param, 64
		dim	c_block_func, 64

		ldim c_label, 1

		//	output dest-code
		d_index		= 0
		d_size		= 0

		d_max		= c_max*4	//	Ƃ肠4{
		sdim d_code, d_max

		d_index = 0
		;gosub *SUB_REMOVE_COMMENT
		repeat 2 : gosub *SUB_LEX_MAIN : loop	//	ǂݗp 2
		gosub *SUB_PARSER_MAIN

		gs_define_clear_temporary
		gs_calculate_namespace_swap	//	swap
		gs_calculate_compile_mode 0,0

		if compile_mapping {
			gs_code_mapping code_index
			if stat == -1 {
				comp_P_error 1
			}
		}

		if s_error {
			gs_code_del code_index
			gs_code_ns_decrease
			_gsc_error_section = GSMD_SECTION_COMPILE
			_gsc_error = s_error
			_gsc_error_info = s_error_info
			if s_error > 0 : return -1
			return s_error
		}

		gs_code_set code_index, d_code, d_index

		sdim d_code, 64

		return code_index
/*
	#deffunc gscript_getbin var p0
		memexpand p0, d_index+1 : poke p0, d_index, 0
		memcpy p0, d_code, d_index, 0, 0
		return
*/

*SUB_LEX_READ
	c_size = gs_strmod_GetCharByte( tempstr, c_pos, c_encode)
	if c_size == 1 {
		c_type = wordgroup( peek( tempstr, c_pos))
		c_pos++
	} else {
		c_pos += c_size
		c_type = WG_CHAR
	}
	c_size--	//	0~noCgɕ␳
	return

*SUB_LEX_STRING_BLOCK	//	ubNǂݔ΂
	//	c_keyword
	repeat
		p = instr( tempstr, c_pos, c_keyword)
		if p == -1 {
			comp_L_error -10, c_keyword	//	@G[
			break
		}
		c_pos += p
		if gs_strmod_GetPreviousCharByte( tempstr, c_pos, c_encode) == 1 {
			if peek( tempstr, c_pos-1) == '\\' {	//	GXP[v
				c_pos += strlen(c_keyword)
				continue
			}
		}
		c_pos += strlen(c_keyword)
		break
	loop
	return

*SUB_LEX_MAIN
		if c_break == 3 : return
		c_break = 0
		repeat 65535
			if c_break == 1 : break
			if c_break == 2 {
				i = (c_parser_stack\p_stack_max)
				p_stack_data(i) = ""
				p_stack_type(i) = TT_EOF
				c_parser_stack++
				c_break = 3
				break
			}
			
			if s_error : break

			if (c_pos >= c_max) {
				c_pos = c_max+1
				c_type = -WG_SPACE
				c_break = 2
				;break
			} else {
				gosub *SUB_LEX_READ
			}

			if (c_crlf != 0) && (c_type != WG_SPACE) : c_crlf--

			if c_mode == -WG_SPACE {	//	^uAXy[X
				if c_type == WG_SPACE {
					c_index = c_pos
					continue
				}
			}

			if ((c_mode == WG_DIV) && (c_type == WG_DIV)) {	//	Rg '//'
				c_mode	= -WG_SPACE
				c_type	= -WG_SPACE
				p = instr(tempstr,c_pos,"\n")
				if p != -1 {
					c_pos	+= p
				} else {
					c_pos	= c_max
				}
			}
			if (c_mode == WG_SEMICOLON) {	//	Rg ';'
				c_mode	= -WG_SPACE
				c_type	= -WG_SPACE
				p = instr(tempstr,c_pos,"\n")
				if p != -1 {
					c_pos	+= p
				} else {
					c_pos	= c_max
				}
			}


			if (c_type != c_mode) {

				if (c_mode == WG_CHAR) {			//	
					if (c_type == WG_NUMBER) {		//	tĂ
						continue
					}
				}

				if (c_mode == WG_MUL) {				//	* 
					if (c_type == WG_CHAR) {		//	tĂ
						c_mode = WG_CHAR
						continue
					}
				}

				if (c_mode == WG_PREPROCESS) {		//	# 
					if (c_type == WG_CHAR) {		//	tĂ #a
						continue
					}
					if (c_type == WG_NUMBER) {		//	tĂAʓ|Ȃ̂ #1a Ȃǂ
						continue
					}
				}

				if (c_type == WG_PREPROCESS) {	//	# ꍇ
					if (c_mode != WG_RETURN_LF) && (c_crlf == 0) {
						comp_L_error -10, "#";,  "Syntax error. '#'"
						break
					}
				}

				if (c_type == WG_DIV) {		//	/ ꍇ͈ꕶ`
					if c_pos < c_max {
						if gs_strmod_GetCharByte( tempstr, c_pos, c_encode) == 1 {
							p = wordgroup(peek(tempstr, c_pos))
							if (p == WG_MUL) {	//	RgubN / * * /
								c_pos++ : p = instr(tempstr, c_pos,"*/")
								if p == -1 {
									if (c_mode == WG_RETURN_LF) {	//	Osꍇ͍s킹
										line_current(line_index)++
										if line_current(line_index) > line_max(line_index) {
											if line_index : line_index--
										}
										c_crlf = 2
									}
									comp_L_error -11
									break
								}
								i = 0 : x = 0
								repeat
									x = instr(tempstr, c_pos+i,"\n")
									if x == -1 : i = cnt : break
									if (i+x) >= p : i = cnt : break
									i += x+2
								loop
								x = "" : repeat i : x += "\n" : loop
								tempstr = strmid(tempstr,0,c_pos-2) + x + strmid(tempstr,c_pos+p+2,c_max)
								c_max = strlen(tempstr)
								c_pos -= 2
								continue
							}
						}
					}
				}

				if (c_mode == WG_RETURN_CR) && (c_type == WG_RETURN_LF) {
					c_mode = WG_RETURN_LF
					continue
				}

				if (abs(c_mode) != WG_SPACE) {
					c_pos--
					c_temp = getpath(strmid(tempstr,c_index,c_pos-c_index-c_size),16)

					;gs_define_search c_temp : p = stat
					gs_define_search2 c_temp, ns_name(ns_index) : p = stat
					if p == 0 {
						if (c_mode == WG_PREPROCESS) {
							comp_L_error -12, c_temp
							break
						}
						;c_func = 0	;"undefined"		//	`AϐƂ
						gosub *SUB_LEX_CHECK_UNDEFINED
						if s_error == 0 {
							i = (c_parser_stack\p_stack_max)
							p_stack_ns(i)		= ns_flag
							p_stack_type(i)		= c_param
							p_stack_data(i)		= c_temp
							p_stack_line(i)		= line_current(line_index)
							p_stack_name(i)		= line_name(line_index)
							c_parser_stack++
							if c_break == 0 : c_break = 1
						}
					} else {
						if p < 0 {
							comp_L_error -21, c_temp
							break
						}
						t = gs_define_get_type(p)

						if (t == GSMD_DEFINE_TYPE_PREPROCESS) {
							;c_func = p;"is function "+p		//	vvZbT߂ƂĒ`Ă
							gs_define_get_value_v p, c_label
							gosub c_label
						}
						if (t == GSMD_DEFINE_TYPE_FUNC) {
							;c_func = p;"is function "+p		//	߂ƂĒ`Ă
							gosub *SUB_LEX_CHECK_FUNCTION
							if s_error == 0 {
								i = (c_parser_stack\p_stack_max)
								p_stack_ns(i)		= ns_flag
								p_stack_type(i)		= TT_FUNCTION
								p_stack_data(i)		= c_temp
								p_stack_param(i)	= c_param
								p_stack_line(i)		= line_current(line_index)
								p_stack_name(i)		= line_name(line_index)
								c_parser_stack++
								if c_break == 0 : c_break = 1
							}
						}
						if (t == GSMD_DEFINE_TYPE_CONST) {		//	萔͓WJ
							c_pos		-= strlen(c_temp)
							;tempsrc		= strmid(tempstr,0,c_pos) + gs_define_get_value_ex(p) + strmid(tempstr,c_pos+strlen(c_temp),c_max)
							tempstr		= strmid(tempstr,0,c_pos) + gs_define_get_value_ex(p) + strmid(tempstr,c_pos+strlen(c_temp),c_max);getpath(tempsrc,16)
							c_max		= strlen(tempstr)
							c_mode		= -WG_SPACE	//	uNw
							c_break		= 0
							continue
						}
						if (t == GSMD_DEFINE_TYPE_CFUNC) || (t == GSMD_DEFINE_TYPE_VARIABLE) || (t == GSMD_DEFINE_TYPE_LABEL) {
							//	֐, ϐ, x
							;c_func = 0
							gosub *SUB_LEX_CHECK_UNDEFINED
							if s_error == 0 {
								i = (c_parser_stack\p_stack_max)
								p_stack_ns(i)		= ns_flag
								p_stack_type(i)		= c_param
								p_stack_data(i)		= c_temp
								p_stack_line(i)		= line_current(line_index)
								p_stack_name(i)		= line_name(line_index)
								c_parser_stack++
								if c_break == 0 : c_break = 1
							}
						}
					}
					c_pos++
				}

				c_index = c_pos-1-c_size
				c_mode = c_type

				if (c_mode == WG_SPACE) {
					c_mode = -WG_SPACE
				}
				if (c_mode == WG_COLON) {		//	R͂ŖĂȂ
					c_mode = -WG_SPACE
				}
				if (c_mode == WG_BRACES_B) {	//	{
					c_mode = WG_NULL
				}
				if (c_mode == WG_BRACES_C) {	//	}
					c_mode = WG_NULL
				}
			}
		loop
		return



//	-------- preprocess --------

	#define global gsc_preprocess_GetArgument	gs_compile_get_preprocess_argument
	#deffunc gs_compile_get_preprocess_argument	var p_var, int p_mode
		sub_flag = p_mode
		gosub *PREPROCESS_GET_STRING
		p_var = c_param
		if sub_return == 0 : c_type = -WG_SPACE
		return sub_return

	#define global gsc_Preprocess	gs_define_add_preprocess

//	#define
*PREPROCESS_DEFINE
	sub_flag = 0
	gosub *PREPROCESS_GET_STRING
	if getpath(c_param,16) == "global" {	//	global w
		if sub_return == 1 {
			comp_L_error -10, "#define"	//	#define global ŏIĂ
		}
		gosub *PREPROCESS_GET_STRING
		p = instr(c_param, 0, "@")			//	@ 邩ׂ
		if p != -1 {						//	@ 
			if (strlen(c_param)-1) == p {	//	abc@ ̂悤ɈԌɂĂ
				poke c_param, p, 0			//	@ 
			}
		}
	} else {
		p = instr(c_param, 0, "@")			//	@ 邩ׂ
		if p != -1 {						//	@ 
			if (strlen(c_param)-1) == p {	//	abc@ ̂悤ɈԌɂĂ
				poke c_param, p, 0			//	@ 
			}
		} else {							//	@ Ȃ
			if ns_flag {
				c_param += "@"+ns_name(ns_index)	//	@+ns_string
			}
		}
	}

	//	 c_param  key@name ̌`Ŋi[̂
	//	c_temp=key, c_param=name ɕ
	//	@name tĂȂꍇ c_param  "" ƂȂ
	p = instr(c_param, 0, "@")
	if p == -1 {
		c_temp = c_param
		c_param = ""
	} else {
		c_temp = strmid(c_param, 0, p)
		c_param = strmid(c_param, p+1, strlen(c_param))
	}

	//	܂ key Ō
	gs_define_searchf c_temp
	if stat {
		//	`݂ #define ɂ`ȊȌꍇ̓G[Ԃ
		if (gs_define_get_type(abs(stat)) != GSMD_DEFINE_TYPE_CONST) {
			comp_L_error -13, c_temp
			return
		}
	}

	//	 key@name Ō
	if c_param != "" {
		c_temp += "@"+c_param
		gs_define_searchf c_temp
		if stat {
			//	`݂ꍇ̓G[Ԃ
			comp_L_error -13, strmid(c_temp,0,strlen(c_temp)-strlen(c_param)-1)+" ("+c_temp+")"
			return
		}
	}

	if sub_return == 1 {
		c_param = ""
	} else {
		sub_flag = 1
		gosub *PREPROCESS_GET_STRING
	}
	if code_deflev > 0 {
		gs_define_user_define c_temp, c_param
	} else {
		gs_define_temp_define c_temp, c_param
	}
	return

//	#undef
*PREPROCESS_UNDEF
	sub_flag = 0
	gosub *PREPROCESS_GET_STRING
	if sub_return != 1 {
		comp_L_error -10, "#undef"
		return
	}

	p = instr(c_param, 0, "@")			//	@ 邩ׂ
	if p != -1 {						//	@ 
		if (strlen(c_param)-1) == p {	//	abc@ ̂悤ɈԌɂĂ
			poke c_param, p, 0			//	@ 
		}
	} else {							//	@ Ȃ
		if ns_flag {
			c_param += "@"+ns_name(ns_index)	//	@+ns_string
		}
	}
	//	key@name Ō
	gs_define_searchf c_param
	if stat {
		//	`݂ꍇ
		if (gs_define_get_type(abs(stat)) == GSMD_DEFINE_TYPE_CONST) {
			gs_define_delete c_param
		}
	}
	return

//	#deflev
*PREPROCESS_DEFLEV
	sub_flag = 0
	gosub *PREPROCESS_GET_STRING
	if sub_return != 1 {
		comp_L_error -10, "#deflev"
		return
	}
	code_deflev = int(c_param)
	return

//	#name
*PREPROCESS_NAME
	sub_flag = 0
	gosub *PREPROCESS_GET_STRING
	if sub_return != 1 {
		comp_L_error -10, "#name"
		return
	}

	if strlen(c_param) >= 2 {
		//	ʓ|̂łőΉ #name "hoge"  #name hoge ɕϊ
		if (peek(c_param,0) == '\"') && (peek(c_param,strlen(c_param)-1) == '\"') {
			c_param = strmid(c_param,1,strlen(c_param)-2)
		}
	} else {
		if strlen(c_param) == 1 {
			if (peek(c_param,0) == '\"') {	//	#name "
				c_param == ""
			}
		}
	}

	ns_index++
	ns_name(ns_index) = c_param
	gs_calculate_namespace ns_name(ns_index)
	ns_flag = (ns_name(ns_index) != "") * 2	//	 or [U[`
	if ns_flag {
		gs_calculate_namespace_flag 2
	}

	return

//	#endname
*PREPROCESS_ENDNAME
	if ns_index == 0 {
		comp_L_error -14
		return
	}
	ns_index--
	gs_calculate_namespace ns_name(ns_index)

	if ns_index == 0 {
		ns_flag = (ns_name(ns_index) != "")		//	(0) or W`(1)
	} else {
		ns_flag = (ns_name(ns_index) != "") * 2	//	(0) or [U[`(2)
		if ns_flag {
			gs_calculate_namespace_flag 2
		}
	}

	return

//	#include
*PREPROCESS_INCLUDE
	replace_head = c_pos-8	//	#include̐擪
	sub_flag = 0
	gosub *PREPROCESS_GET_STRING
	if sub_return != 1 {
		comp_L_error -10, "#include"
		return
	}

	//	ʓ|̂łőΉ #include "hoge"  #include hoge ɒu
	if (peek(c_param,0) == '\"') && (peek(c_param,strlen(c_param)-1) == '\"') {
		c_param = strmid(c_param,1,strlen(c_param)-2)
	}

	//	`
	c_param = gs_compile_format_path(c_param)

	//	<windows>
		if peek( c_param, 1) != ':' {
			//	΃pX̏ꍇ
			//	\[X̃pXt
			c_param = getpath( line_path(line_index), 32) + c_param
		}
		//	tpX`
		c_param = gs_compile_get_fullpath(c_param)
	//	</windows>

	//	œ
	c_param = getpath( c_param, 16)

	exist c_param
	if strsize == -1 {
		comp_L_error -15, c_param
		return
	}

	repeat line_index
		if line_path(cnt) == c_param {
			comp_L_error -20, c_param
			break
		}
	loop
	if s_error : return

	sdim c_temp, strsize+1
	bload c_param, c_temp
	gs_compile_crlf c_temp			//	sR[hƍsJEg
	line_current(line_index)++		//	݂̃\[X̍s𑝂₷
	line_index++
	if line_index >= INCLUDE_LEVEL_LIMIT {
		line_index--
		comp_L_error -19	//	include level limit
		return
	}
	line_max(line_index) = stat+1	//	s͉s̐+1
	line_current(line_index) = 1
	line_name(line_index) = getpath(c_param,8)
	line_path(line_index) = c_param

	//	Ƃ肠蔲
	tempstr = strmid(tempstr, 0, replace_head) + c_temp + strmid(tempstr, c_pos, strlen(tempstr))

	sdim c_temp, 64
	c_pos = replace_head
	c_max = strlen(tempstr)

	c_pos--
	c_type = WG_SPACE
	c_crlf = 2
	c_break = 0
	return



//	sub_flag=0̏ꍇ̓Xy[X؂ƂĔFA1̏ꍇ͖B
//	܂ sub_flag=0 ͈܂ꍇA=1 ͍s܂Ŏ擾ꍇɎw肷B
//	sub_return ɋ؂v̂ sub_flag=0  sub_return=1 ̏ꍇ͍sɓBĈȍ~͖̈ƂȂB
//	̂ c_param ɑB
*PREPROCESS_GET_STRING
	sub_mode = 0
	sub_pos	= c_pos
	sub_return = 0	//	؂v̎ 0=Xy[X, 1=sRgȂǂ̍s
	sub_state = 0
	c_type = -WG_SPACE
	bw_length = 1
	repeat
		if (c_pos >= c_max) {
			bw_length = 0
			c_break = 2
			sub_return = 1
			break
		}
		c_mode = c_type
		gosub *SUB_LEX_READ

		if (c_type == WG_CHAR) || (c_type == WG_NUMBER) || (c_type == WG_COMMA) {
			if sub_state == 1 : break
			continue
		}

		if (c_type == WG_D_QORTATION) {
			if sub_state == 1 : break
			c_keyword = "\"" : gosub *SUB_LEX_STRING_BLOCK : if s_error : break
			continue
		}
		if (c_type == WG_QORTATION) {
			if sub_state == 1 : break
			c_keyword = "'" : gosub *SUB_LEX_STRING_BLOCK : if s_error : break
			continue
		}

		if (c_type == WG_SPACE) {		//	Xy[XA^u
			if c_mode == -WG_SPACE : sub_pos = c_pos : c_type = -WG_SPACE : continue
			if sub_flag == 0 {
				sub_state = 1
				;break
			}
			continue
		}

		if (c_type == WG_RETURN_LF) {	//	LF
			if (c_mode == WG_RETURN_CR) {
				bw_length = 2
				sub_return = 1
				break
			}
		}
		if (c_type == WG_SEMICOLON) {	//	Rg ; 
			sub_return = 1
			break
		}
		if (c_type == WG_DIV) {			//	Rg // 
			if (c_mode == WG_DIV) {
				bw_length = 2
				sub_return = 1
				break
			}
		}

		if (c_type == WG_MUL) {			//	Rg / * 
			if (c_mode == WG_DIV) {
				p = instr(tempstr, c_pos,"*/")
				if p == -1 {
					comp_L_error -11
					break
				}
				i = 0 : x = 0
				repeat
					x = instr(tempstr, c_pos+i,"\n")
					if x == -1 : i = cnt : break
					if (i+x) >= p : i = cnt : break
					i += x+2
				loop
				x = "" : repeat i : x += "\n" : loop
				tempstr = strmid(tempstr,0,c_pos-2) + x + strmid(tempstr,c_pos+p+2,c_max)
				c_max = strlen(tempstr)
				c_pos -= 2
				c_type = 0;-WG_SPACE
				continue
			}
		}
	loop

	c_pos -= bw_length
	c_param = strmid(tempstr, sub_pos, c_pos-sub_pos)
	;c_param = strtrim(c_param, 2, ' ')	//	E[ : ȂǂŃXy[X]vɓꍇ̂Ŏ菜
	;c_param = strtrim(c_param, 2, '\t')
	gs_strmod_removespace c_param, 2, c_encode
	;dialog "["+c_param+"]\n"+sub_pos+" "+c_pos
	return



//	-------- lex --------

//	\L[[hɖ
*SUB_LEX_CHECK_UNDEFINED
	if c_temp == "\n" {
		c_param = TT_RETURN
	
		;dialog "line_index: "+line_index+"\nline_current:"+line_current(line_index)+"\nline_name: "+line_name(line_index)
		line_current(line_index)++
		if line_current(line_index) > line_max(line_index) {
			if line_index : line_index--
		}
		c_crlf = 2
		return
	}
	if c_temp == "{"	: c_param = TT_BRACES_B : return
	if c_temp == "}"	: c_param = TT_BRACES_C : return

	p = strlen(c_temp)
	;c_func		= 0
	sub_pos		= c_pos - p
	c_type		= WG_SPACE	//	JñXy[XL
	;c_pos--

	gosub *SUB_LEX_CHECK_START
	c_temp = c_param
	if peek(c_temp,0) == '*' {
		c_param = TT_LABEL
	} else {
		c_param = TT_VARIABLE
	}
	return

//	߃L[[h
*SUB_LEX_CHECK_FUNCTION
	sub_pos		= c_pos
	c_type		= -WG_SPACE	//	JñXy[X𖳌
	gosub *SUB_LEX_CHECK_START
	return

//	擾 c_param Ɋi[
*SUB_LEX_CHECK_START
	sub_mode		= 0
	sub_bracket		= 0
	sdim sub_bracket_type, 128

	bw_length = 1
	
	repeat
		if (c_pos >= c_max) {
			bw_length = 0
			c_break = 2
			break
		}
		c_mode = c_type
		gosub *SUB_LEX_READ

		if (c_type == WG_CHAR) || (c_type == WG_NUMBER) || (c_type == WG_COMMA) {
			continue
		}

		if (c_type == WG_D_QORTATION) {
			c_keyword = "\"" : gosub *SUB_LEX_STRING_BLOCK : if s_error : break
			continue
		}
		if (c_type == WG_QORTATION) {
			c_keyword = "'" : gosub *SUB_LEX_STRING_BLOCK : if s_error : break
			continue
		}

		if (c_type == WG_SPACE) {	//	Xy[XA^u
			if c_mode == -WG_SPACE : sub_pos = c_pos
			continue
		}

		if (c_type == WG_PARENTHESIS_B) {	//	(
			sub_bracket++
			poke sub_bracket_type, sub_bracket, WG_PARENTHESIS_B
			continue
		}
		if (c_type == WG_PARENTHESIS_C) {	//	)
			if (sub_bracket == 0) {
				comp_L_error -10, ")"
				break
			}
			if (peek(sub_bracket_type, sub_bracket) != WG_PARENTHESIS_B) {
				comp_L_error -10, ")"
				break
			}
			sub_bracket--
			continue
		}

		if (c_type == WG_BRACKET_B) {	//	[
			sub_bracket++
			poke sub_bracket_type, sub_bracket, WG_BRACKET_B
			continue
		}
		if (c_type == WG_BRACKET_C) {	//	]
			if (sub_bracket == 0) {
				comp_L_error -10, "]"
				break
			}
			if (peek(sub_bracket_type, sub_bracket)) != WG_BRACKET_B {
				comp_L_error -10, "]"
				break
			}
			sub_bracket--
			continue
		}

		if (c_type == WG_BRACES_B) {	//	{
			if sub_bracket {	//	̊ʓɂꍇ̓G[
				comp_L_error -10, "{"
				break
			}
			//	̕mF
			if (c_pos == c_max) : break
			if gs_strmod_GetCharByte( tempstr, c_pos, c_encode) == 1 {
				if wordgroup(peek(tempstr, c_pos)) == WG_D_QORTATION {	//	{" subN
					c_keyword = "\"}" : gosub *SUB_LEX_STRING_BLOCK
					if s_error {
						comp_L_error -16
						break
					}
					line_current(line_index) += gs_compile_get_crlf_count(strmid(tempstr, sub_pos, c_pos-sub_pos))	//	̉sZ
					continue
				}
			}
			break
		}

		if (c_type == WG_BRACES_C) {	//	}
			if sub_bracket {	//	̊ʓɂꍇ̓G[
				comp_L_error -10, "}"
				break
			}
			break
		}

		if (c_type == WG_COLON) {		//	:
			if (sub_bracket == 0) {
				break
			}
		}
		;if (c_type == WG_RETURN_CR) {	//	CR
		;}
		if (c_type == WG_RETURN_LF) {	//	LF
			if (c_mode == WG_RETURN_CR) {
				if (sub_bracket == 0) {
					bw_length = 2
					break
				}
			}
		}
		if (c_type == WG_SEMICOLON) {	//	Rg ; 
			break
		}
		if (c_type == WG_DIV) {			//	Rg // 
			if (c_mode == WG_DIV) {
				bw_length = 2
				c_type = WG_SEMICOLON
				break
			}
		}

		if (c_type == WG_MUL) {			//	Rg / * 
			if (c_mode == WG_DIV) {
				p = instr(tempstr, c_pos,"*/")
				if p == -1 {
					comp_L_error -11
					break
				}
				i = 0 : x = 0
				repeat
					x = instr(tempstr, c_pos+i,"\n")
					if x == -1 : i = cnt : break
					if (i+x) >= p : i = cnt : break
					i += x+2
				loop
				x = "" : repeat i : x += "\n" : loop
				tempstr = strmid(tempstr,0,c_pos-2) + x + strmid(tempstr,c_pos+p+2,c_max)
				c_max = strlen(tempstr)
				c_pos -= 2
				c_type = -WG_SPACE
			}
		}

	loop
	if s_error : return
	c_pos -= bw_length
	c_param = strmid(tempstr, sub_pos, c_pos-sub_pos)
	;c_param = strtrim(c_param, 2, ' ')	//	E[ : ȂǂŃXy[X]vɓꍇ̂Ŏ菜
	;c_param = strtrim(c_param, 2, '\t')
	gs_strmod_removespace c_param, 2, c_encode
	;dialog ""+c_param+"\n"+sub_pos+" "+c_pos
	return



;	#define		COMP_PARSER_DEBUG

//	parser
*SUB_PARSER_MAIN
		repeat 65535

			p_type = p_stack_type(p_stack_index)
			if p_type == TT_EOF {
#ifdef COMP_PARSER_DEBUG
				mes "[EOF]"
#endif
				gosub *GSCRIPT_FUNC_RULE_EOF
				break
			}
			if p_type == TT_FUNCTION {
				p_code = p_stack_data(p_stack_index)
				p_param = p_stack_param(p_stack_index)
#ifdef COMP_PARSER_DEBUG
				mes "func ["+p_code+"] ["+p_param+"]"
#endif
				gosub *GSCRIPT_FUNC_RULE_DEFAULT
				goto *@f
			}
			if p_type == TT_VARIABLE {
				p_code = p_stack_data(p_stack_index)
				gosub *GSCRIPT_VARIABLE_RULE_DEFAULT
#ifdef COMP_PARSER_DEBUG
				mes "var["+p_code+"]"
#endif
				goto *@f
			}
			if p_type == TT_LABEL {
				p_code = p_stack_data(p_stack_index)
				p_param = p_stack_ns(p_stack_index)
				gosub *GSCRIPT_LABEL_RULE_DEFAULT
#ifdef COMP_PARSER_DEBUG
				mes "label["+p_code+"]"
#endif
				goto *@f
			}
			
			if p_type == TT_BRACES_B {
				p_code = p_stack_data(p_stack_index)
				gosub *GSCRIPT_BRACES_B_RULE_DEFAULT
#ifdef COMP_PARSER_DEBUG
				mes " "+p_code
#endif
				goto *@f
			}
			if p_type == TT_BRACES_C {
				p_code = p_stack_data(p_stack_index)
				gosub *GSCRIPT_BRACES_C_RULE_DEFAULT
#ifdef COMP_PARSER_DEBUG
				mes " "+p_code
#endif
				goto *@f
			}
			if p_type == TT_RETURN {
				p_code = p_stack_data(p_stack_index)
				gosub *GSCRIPT_RETURN_RULE_DEFAULT
#ifdef COMP_PARSER_DEBUG
				;mes "  [CRLF]"
#endif
				goto *@f
			}
			*@

			p_stack_index = (p_stack_index+1)\p_stack_max
			gosub *SUB_LEX_MAIN
			if s_error : break
		loop
		return




		
;p_type = p_stack_type(p_stack_index)
//	d_code size sheck
*GSCRIPT_CHECK_D_CODE_SIZE
	if ((d_index + d_size) >= d_max) {
		d_max += d_size + 4096
		memexpand d_code, d_max
	}
	return

//	-------- rule and code generate --------

//	rule-eof
*GSCRIPT_FUNC_RULE_EOF
	p_type = TT_RETURN : gosub *GSCRIPT_RETURN_RULE_DEFAULT	//	sƂăubN

	poke d_code, d_index, 'e' : d_index++	//	end of data	1byte
	return

//	rule-variable operation (expr)
*GSCRIPT_VARIABLE_RULE_DEFAULT
	gs_calculate_makebin_var p_code
	i = stat
	if i < 0 {
		comp_P_error 1, p_code	//	p
		return
	}

	d_size = 3+i : gosub *GSCRIPT_CHECK_D_CODE_SIZE
	p_addr = d_index
	poke d_code, d_index, 'v' : d_index++			//	variable	1byte
	wpoke d_code, d_index, i : d_index += 2			//	param_size	2byte
	if i > 0 {
		memcpy d_code, gs_calculate_bin, i, d_index, 0 : d_index += i	//	param
	}
	return

//	rule-label
*GSCRIPT_LABEL_RULE_DEFAULT
	;strtrim p_code, 0, ' ' : strtrim p_code, 0, '\t'
/*
	if compile_mode == 0 {
		p = instr(p_code,0,"@")
		if p != -1 {
			if (strlen(p_code)-1) == p {
				poke p_code, p, 0
			}
		} else {
			if ns_flag {
				p_code += "@"+ns_name(ns_index)
			}
		}
		if gs_label_search(p_code) != -1 {
			if gs_label_get_flag(gs_label_search(p_code)) == 1 {
				comp_P_error -17, p_code		;1, "Label "+p_code+" is aleady exist."
				return
			}
		}
		gs_label_add p_code, code_index, d_index, 1
	} else {
		p = instr(p_code,0,"@")
		if p == -1 {
			if p_param == 0 : p_code += "@"
			if p_param == 2 : p_code += "@"+ns_name(ns_index)
		}
		gs_code_add_label code_index, p_code, d_index
		if stat == -1 {
			comp_P_error -17, p_code		;1, "Label "+p_code+" is aleady exist."
		}
	}
*/
	if compile_mapping {	//	RpCɃ}bsOsꍇ͊̃x`FbN
		p_temp = p_code
		p = instr(p_code,0,"@")
		if p != -1 {
			if (strlen(p_code)-1) == p {
				poke p_code, p, 0
			}
		} else {
			if ns_flag {
				p_code += "@"+ns_name(ns_index)
			}
		}
		if gs_label_search(p_code) != -1 {
			if gs_label_get_flag(gs_label_search(p_code)) == 1 {
				comp_P_error -17, p_code
				return
			}
		}
		p_code = p_temp
	}
	p = instr(p_code,0,"@")
	if p == -1 {
		if p_param == 0 : p_code += "@"
		if p_param == 2 : p_code += "@"+ns_name(ns_index)
	}
	gs_code_add_label code_index, p_code, d_index
	if stat == -1 {
		comp_P_error -17, p_code
	}

	return

//	rule-braces '{'
*GSCRIPT_BRACES_B_RULE_DEFAULT
	if p_block {
		if gs_function_get_rule_type(p_block_func(p_block)) == 1 {
			gs_function_get_rule p_block_func(p_block), p_label
			p_call = p_block_type(p_block)	//	Ăяov on_block
			gosub p_label
		}
	}
	if p_block {
		if p_block_type(p_block) == PCD_BLOCK_TYPE_LINE {
			p_block_type(p_block) = PCD_BLOCK_TYPE_BRACES
			return
		}
		comp_P_error -10, "}"
	}
	comp_P_error -10, "}"
	return

//	rule-braces '}'
*GSCRIPT_BRACES_C_RULE_DEFAULT
	if p_block {
		if gs_function_get_rule_type(p_block_func(p_block)) == 1 {
			gs_function_get_rule p_block_func(p_block), p_label
			p_call = p_block_type(p_block)	//	Ăяov on_block
			gosub p_label
		}
	}
	if p_block {
		if p_block_type(p_block) == PCD_BLOCK_TYPE_BRACES {
			p_block--
			return
		}
	}
	comp_P_error -10, "}"
	return

//	rule-line break '\n'
*GSCRIPT_RETURN_RULE_DEFAULT
	repeat
		if p_block {
			if gs_function_get_rule_type(p_block_func(p_block)) == 1 {
				gs_function_get_rule p_block_func(p_block), p_label
				p_call = p_block_type(p_block)	//	Ăяov on_block
				gosub p_label
			}
			if p_block_type(p_block) == PCD_BLOCK_TYPE_LINE {
				p_block--
				continue
			}
		}
		break
	loop
	return


//	p_type	=	stack_type
//	p_code	=	func_name
//	p_param	=	func_param
//	p_func	=	func_id

//	rule-function common
*GSCRIPT_FUNC_RULE_DEFAULT
	if p_block {
		if gs_function_get_rule_type(p_block_func(p_block)) == 1 {
			gs_function_get_rule p_block_func(p_block), p_label
			p_call = p_block_type(p_block)	//	Ăяov on_block
			gosub p_label
		}
	}
	;gs_define_search2 p_code : p_func = gs_define_get_value(stat)		//	name  id 
	p_func = gs_function_search(p_code)

	p = gs_function_get_p_count(p_func)
	gs_calculate_makebin p_param : i = stat

	if i < 0 {
		comp_P_error 1, p_code+" "+p_param
		return
	}

	if (gs_calculate_element_check() == 0) {
		i = 0
	}

	if (i > 0) {
		if (gs_calculate_getparam() > p) {	//	p[^
			comp_P_error -18, p_code+" "+p_param
			return
		}
	}

	;if p_code == "mes" : dialog ""+gs_calculate_info(gs_calculate_bin)

	d_size = 14+i : gosub *GSCRIPT_CHECK_D_CODE_SIZE
	p_addr = d_index
	p = (gs_function_get_rule_type(p_func)==1)
	poke d_code, d_index, 'f' : d_index++					//	function	1byte
	wpoke d_code, d_index, p_func : d_index += 2			//	func_id		2byte

	if gs_function_get_p_count(p_func) > 0 {
		wpoke d_code, d_index, i : d_index += 2					//	param_size	2byte
		if (i > 0) {
			memcpy d_code, gs_calculate_bin, i, d_index, 0 : d_index += i	//	param
		}
	}

	if gs_function_get_rule_type(p_func) == 1 {
		gs_function_get_rule p_func, p_label
		p_call = PCD_FUNC_INIT	//	Ăяov init
		gosub p_label
	}

	return


//	-------- exception rule --------
/*
	O[쐬p

	p_type		stack_type	(݂̃g[N^Cv)
				nÕX^bÑg[N^Cv p_stack_type((p_stack_index+p_stack_max - n )\p_stack_max) ŏE

	p_code		func_name	(ߖ)
	p_param		func_param	(߈)
	p_func		func_id		(ID)
	d_index		݂݈̏ʒu


	p_call		Ăяov
				p_call == PCD_FUNC_INIT				FUNC_RULE_DEFAULTŊ{񂾒1Ăяo
				p_call == PCD_BLOCK_TYPE_LINE		CubNŃg[NɌX̏O1Ăяo
				p_call == PCD_BLOCK_TYPE_BRACES		ʃubNŃg[NɌX̏O1Ăяo
				p_call == PCD_BLOCK_TYPE_FUNC		߃ubNŃg[NɌX̏O1Ăяo

	p_block					݂̃ubNX^bNl
	p_block_type(p_block)	ubÑ^Cvl (PCD_BLOCK_TYPE_LINE, PCD_BLOCK_TYPE_BRACES, PCD_BLOCK_TYPE_FUNC)

	ȃftHg
		'{'
			CubNɂꍇɂ̃ubN^CvʃubNɏB
			 (p_call == PCD_BLOCK_TYPE_LINE) ̌ɎsB

		'}'
			ʃubNɂꍇɂ̃ubNB
			 (p_call == PCD_BLOCK_TYPE_LINE) ̌ɎsB
	
		'\n'
			CubNɂꍇɂ̃ubNB
			 (p_call == PCD_BLOCK_TYPE_LINE) ̌ɎsB
*/


//	rule-function "if"
*GSCRIPT_FUNC_RULE_IF
	if p_call == PCD_FUNC_INIT {						//	init	߂܂ꂽɌĂяo
		p_block++										//	ubN\z
		p_block_type(p_block)	= PCD_BLOCK_TYPE_LINE	//	CubN
		p_block_func(p_block)	= p_func				//	func_id
		p_block_param(p_block)	= d_index				//	ǉ̈̃AhX
		d_index += 4
		return
	}
	if p_call == PCD_BLOCK_TYPE_LINE {						//	on_block line	̖߂ō\zꂽCubNŃg[NɌĂяo
		if p_type == TT_RETURN {							//	s
			lpoke d_code, p_block_param(p_block), d_index	//	CfbNXif̒ǉ̈ɏ
		}
		// else  RULE_ELSE ̂قŏ
		return
	}

	if p_call == PCD_BLOCK_TYPE_BRACES {					//	on_block bracket	̖߂ō\zꂽʃubNŃg[NɌĂяo
		if p_type == TT_BRACES_C {							//	} 
			lpoke d_code, p_block_param(p_block), d_index	//	CfbNXif̒ǉ̈ɏ
		}
		return
	}
	return

//	rule-function "else"
*GSCRIPT_FUNC_RULE_ELSE
	if p_call == PCD_FUNC_INIT {				//	init	߂܂ꂽɌĂяo
		p = p_stack_type((p_stack_index+p_stack_max-1)\p_stack_max)		//	1ÕX^bN
		if p == TT_RETURN {												//	1Osꍇ
			p = p_stack_type((p_stack_index+p_stack_max-2)\p_stack_max)	//	ɑO1
		}
		if p == TT_BRACES_C {	//	O }
			p_block++ //	ubNグ
			i = gs_function_search("if")
			if p_block_func(p_block) == i {							//	OifɂubNꍇ
				lpoke d_code, p_block_param(p_block), d_index+4		//	else ̎̃CfbNXif̒ǉ̈ɏ
				p_block--											//	ubN
				goto *@f
			}
			comp_P_error -10, "else"
			return
		}
		if p_block {	//	ubN
			if p_block_type(p_block) == PCD_BLOCK_TYPE_LINE {
				i = gs_function_search("if")
				if p_block_func(p_block) == i {						//	if ̃CubNꍇ
					lpoke d_code, p_block_param(p_block), d_index+4	//	else ̎̃CfbNXif̒ǉ̈ɏ
					p_block--										//	ubN
					goto *@f
				}
			}
			comp_P_error -10, "else"
			return
		}
		comp_P_error -10, "else"
		return

		*@
		p_block++										//	ubN\z
		p_block_type(p_block)	= PCD_BLOCK_TYPE_LINE	//	CubN
		p_block_func(p_block)	= p_func				//	func_id
		p_block_param(p_block)	= d_index				//	ǉ̈̃AhX
		d_index += 4
		return
	}

	if p_call == PCD_BLOCK_TYPE_LINE {							//	on_block line	̖߂ō\zꂽCubNŃg[NɌĂяo
		if p_type == TT_RETURN {								//	s
			lpoke d_code, p_block_param(p_block), d_index		//	CfbNXelse̒ǉ̈ɏ
		}
		// else  RULE_ELSE ̂قŏ
		return
	}

	if p_call == PCD_BLOCK_TYPE_BRACES {					//	on_block bracket	̖߂ō\zꂽʃubNŃg[NɌĂяo
		if p_type == TT_BRACES_C {							//	} 
			lpoke d_code, p_block_param(p_block), d_index	//	CfbNXelse̒ǉ̈ɏ
		}
		return
	}

	return

//	rule-function "repeat"
*GSCRIPT_FUNC_RULE_REPEAT
	if p_call == PCD_FUNC_INIT {						//	init	߂܂ꂽɌĂяo
		p_block++										//	ubN\z
		p_block_type(p_block)	= PCD_BLOCK_TYPE_FUNC	//	߃ubN
		p_block_func(p_block)	= p_func				//	func_id
		p_block_param(p_block)	= d_index				//	ǉ̈̃AhX
		d_index += 4
		return
	}
	return

//	rule-function "loop"
*GSCRIPT_FUNC_RULE_LOOP
	if p_call == PCD_FUNC_INIT {				//	init	߂܂ꂽɌĂяo
		if p_block {	//	ubN
			if p_block_type(p_block) == PCD_BLOCK_TYPE_FUNC {
				i = gs_function_search("repeat")
				if p_block_func(p_block) == i {	//	repeat ̖߃ubNꍇ
					lpoke d_code, p_block_param(p_block), d_index	//	loop ̎̃CfbNXrepeat̒ǉ̈ɏ
					p_block--										//	ubN
					return
				}
			}
			comp_P_error -10, "loop"
			return
		}
		comp_P_error -10, "loop"
		return
	}
	return

//	rule-function "break"
*GSCRIPT_FUNC_RULE_BREAK
	if p_call == PCD_FUNC_INIT {				//	init	߂܂ꂽɌĂяo
		i = gs_function_search("repeat")
		p = p_block
		//	ł߂ repeat ubNT
		repeat
			if p_block {	//	ubN
				if p_block_type(p_block) == PCD_BLOCK_TYPE_FUNC {
					if p_block_func(p_block) == i {	//	repeat ubN
						//	break ̒ǉ̈repeat̗\AhX
						lpoke d_code, d_index, p_block_param(p_block)
						d_index += 4
						break
					}
				}
				p_block--	//	ubN
				continue
			}
			comp_P_error -10, "break"
			break
		loop
		if s_error : return
		p_block = p		//	ubN
		return
	}
	return

//	rule-function "continue"
*GSCRIPT_FUNC_RULE_CONTINUE
	if p_call == PCD_FUNC_INIT {				//	init	߂܂ꂽɌĂяo
		i = gs_function_search("repeat")
		p = p_block
		//	ł߂ repeat ubNT
		repeat
			if p_block {	//	ubN
				if p_block_type(p_block) == PCD_BLOCK_TYPE_FUNC {
					if p_block_func(p_block) == i {	//	repeat ubN
						//	continue ̒ǉ̈1repeat̗\AhX
						lpoke d_code, d_index, p_block_param(p_block)
						d_index += 4
						break
					}
				}
				p_block--	//	ubN
				continue
			}
			comp_P_error -10, "continue"
			break
		loop
		if s_error : return
		p_block = p		//	ubN
		return
	}
	return

//	rule-function "exgoto"
*GSCRIPT_FUNC_RULE_EXGOTO
	if p_call == PCD_FUNC_INIT {				//	init	߂܂ꂽɌĂяo
		//	p[^̌ɋԖ
		if ns_flag {
			i = strlen(ns_name(ns_index))
			d_size = 1+i : gosub *GSCRIPT_CHECK_D_CODE_SIZE
			poke d_code, d_index, i : d_index++
			memcpy d_code, ns_name(ns_index), i, d_index, 0 : d_index += i
		} else {
			poke d_code, d_index, 0 : d_index++
		}
	}
	return

//	rule-function "exgosub"
*GSCRIPT_FUNC_RULE_EXGOSUB
	if p_call == PCD_FUNC_INIT {				//	init	߂܂ꂽɌĂяo
		//	p[^̌ɋԖ
		if ns_flag {
			i = strlen(ns_name(ns_index))
			d_size = 1+i : gosub *GSCRIPT_CHECK_D_CODE_SIZE
			poke d_code, d_index, i : d_index++
			memcpy d_code, ns_name(ns_index), i, d_index, 0 : d_index += i
		} else {
			poke d_code, d_index, 0 : d_index++
		}
	}
	return

#global

gs_compile_init

#endif